/*
 * FILE:    time.h
 * PROGRAM: RAT
 * AUTHOR:  I.Kouvelas
 * 
 * $Revision: 1.5 $
 * $Date: 1998/07/08 20:53:21 $
 *
 * Copyright (c) 1995,1996 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, is permitted, for non-commercial use only, provided
 * that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Computer Science
 *      Department at University College London
 * 4. Neither the name of the University nor of the Department may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 * Use of this software for commercial purposes is explicitly forbidden
 * unless prior written permission is obtained from the authors.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _rat_time_h_
#define _rat_time_h_

#include "rat_types.h"

struct s_fast_time;
struct s_time;

struct s_fast_time *new_fast_time(int freq);
void                free_fast_time(struct s_fast_time *ft);
struct s_time      *new_time(struct s_fast_time *ft, int freq);
void	            free_time(struct s_time *tp);

void     time_advance(struct s_fast_time *ft, int freq, u_int32 time);
void     change_freq(struct s_time *tp, int freq);
int      get_freq(struct s_time *tp);
u_int32  get_time(struct s_time *tp);

u_int32	convert_time(u_int32 ts, struct s_time *from, struct s_time *to);

/* Horrid little routines to determine wrap around */
int      ts_gt(u_int32 t1, u_int32 t2);
u_int32  ts_abs_diff(u_int32 t1, u_int32 t2);

#endif /* _rat_time_h_ */
